/*
getp4.c  Version 0.2.0 Illinois Pick 4 Odds
Copyright (C) 2002-2005  dondalah@ripco.com (Dondalah)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License as
published by the Free Software Foundation; either version 2 of
the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to:

	Free Software Foundation, Inc.
	59 Temple Place - Suite 330
	Boston, MA  02111-1307, USA.
*/

/*
Usage:
    	int option;
    	double odds;
    	double getp4(int option);
    	odds = getp4(option);
*/

/* Option is defined in pick4.h */

#include <stdio.h>
#include <math.h>
#include "pick4.h"

#define TENFOUR (10.0 * 10.0 * 10.0 * 10.0)

double getp4(option)
int option;
   {
   double bottom;
   double top;
   double prob,odds;

   if (option < STRAIGHT || option > BOX)
      {
      fprintf(stderr,"getp4: invalid option %d\n",
         option);
      exit(1);
      } /* invalid option */

   if (option == STRAIGHT)
      {
      /***********************************************************/
      /*                                                         */
      /*  C(4,4)                                                 */
      /*  ------                                                 */
      /*   n^r                                                   */
      /*                                                         */
      /***********************************************************/
      top = combo(4,4);
      bottom = TENFOUR;
      prob = top / bottom;
      odds = 1.0 / prob;
      return(odds);
      } /* straight */

   else if (option == BOX)
      {
      /***********************************************************/
      /*                                                         */
      /*  P(4,4)                                                 */
      /*  ------                                                 */
      /*   n^r                                                   */
      /*                                                         */
      /***********************************************************/
      top = permute(4,4);
      bottom = TENFOUR;
      prob = top / bottom;
      odds = 1.0 / prob;
      return(odds);
      } /* box */

   fprintf(stderr,"getp4: edit failed "
      "when option is %d\n", option);
   exit(1);
   } /* getp4 */
